MainKernel
MainKernel_Start
	sta WSYNC
	sta HMOVE

	ldy temp
	lda INPT0
	bpl Doit
	.byte $2C
Doit
	sty paddle

	ldy rabcntr
	cpy #RABBITH
	bcc MainKernel_Rabbit
	lda #0					;2
	.byte $2C				;4
MainKernel_Rabbit
	lda (p0ptr),Y			;5+1 from branch
	sta GRP0
	dey
	sty rabcntr

	dec bakcntr
	bmi MainKernel_Background

	ldy belcntr
	bmi MainKernel_NewBell

	lda level+1
	bne MainKernel_NormalStarfield
	lda level
	lsr
	adc temp
	cmp #KLINES-30
	bcs MainKernel_Starfield
	ldy #0
	beq MainKernel_NoStarfield

MainKernel_NormalStarfield
	lsr
	lda level
	ror
	adc temp
MainKernel_Starfield
	tay
MainKernel_NoStarfield
	lda Starfield,Y

	sta HMCLR				;NOTE: we wrap around the screen around here

	sta PF2
	lda Starfield+31,Y
	sta PF1

	;make bells close to the background's edge fade
	ldy bakcntr
	cpy #BELLH
	bcs MainKernel_NoBellFade
	sty COLUP1
MainKernel_NoBellFade

	;are we still above the bell?
	ldy belcntr
	cpy #BELLH
	bcs MainKernel_Black

	;calculate animation frame pointer
	lda bells+1,X
	and #$F8
	sta temp+1
	beq MainKernel_Black
	bne MainKernel_NonBlack

	;we need to do the repositioning here or the branch to MainKernel_Start won't reach
MainKernel_NewBell
	iny				;when we get here Y is always $FF
	sty GRP1		;hence this is one byte cheaper than LDA #0, STA GRP1
	lda #BELLH+GAP-2
	sta belcntr
	inx
	inx
	lda bells,X

	;reposition bell/bird
	clc
	sta WSYNC
DivideLoop3
	sbc #15
	bcs DivideLoop3
	eor #7
	nop				;we're doing STA ZP, not STA ZP,X below, so we need to waste two cycles
	asl
	asl
	asl
	asl
	sta HMP1
	sta RESP1

	;Note: thanks to BXMAX being smaller than XMAX we have enough time for
	;      a DEC here, which ends up saving us ROM in other place
	dec temp
	bne MainKernel_GotoStart
	jmp MainKernel_Ret

MainKernel_Black
	lda #0
	.byte $2C
MainKernel_NonBlack
	lda (temp+1),Y
	sta GRP1
	dec belcntr
	dec temp
	beq MainKernel_Finished
MainKernel_GotoStart
	jmp MainKernel_Start

MainKernel_Background
	lda #3
	sta NUSIZ1
	sta RESP1
	lda bakcntr
	clc
	adc #BACKGH
	bmi MainKernel_BurnRemaining
	tay
	lda Background0,Y

	sta WSYNC
	sta PF0
	lda BackgroundBackground,Y
	sta COLUBK
	lax PineColor,Y
	lda Pine,Y
	sta RESP1
	sta GRP1
	stx COLUP1
	lda BackgroundColor,Y
	sta RESP1
	sta COLUPF
	lda Background1,Y
	sta PF1
	nop
	sta RESP1
	lda Background2,Y
	sta PF2

	dec temp
	beq MainKernel_Finished

	;do a WSYNC here instead of jumping to MainKernel_Start
	;this gets rid of the black HMOVE lines in the background
	sta WSYNC

	ldy rabcntr
	cpy #RABBITH
	bcc MainKernel_Rabbit2
	lda #0					;2
	.byte $2C				;4
MainKernel_Rabbit2
	lda (p0ptr),Y			;5+1 from branch
	sta GRP0
	dey
	sta RESP1
	sty rabcntr
	nop

	dec bakcntr
	sta RESP1
	nop
	nop

	jmp MainKernel_Background


	;FIXME: this is a little silly - we usually (always?) end up burning exactly one line
MainKernel_BurnRemaining
	sta WSYNC
	lda #0
	sta GRP1
	dec temp
	beq MainKernel_Finished
	sta WSYNC
	sta GRP0
	sta WSYNC
MainKernel_Finished
	jmp MainKernel_Ret

	echo "MainKernel: [", MainKernel, ",", *, ")"